
From: Trond Myklebust <trond.myklebust@fys.uio.no>

RPCSEC_GSS: Instead of having gss_get_mic allocate memory for the mic,
require the caller to pass an output buffer whose data pointer already points
to preallocated memory.


---

 net/sunrpc/auth_gss/auth_gss.c      |    5 +++--
 net/sunrpc/auth_gss/gss_krb5_seal.c |    4 ----
 2 files changed, 3 insertions(+), 6 deletions(-)

diff -puN net/sunrpc/auth_gss/auth_gss.c~nfs-12-gss_nokmalloc net/sunrpc/auth_gss/auth_gss.c
--- 25/net/sunrpc/auth_gss/auth_gss.c~nfs-12-gss_nokmalloc	2004-01-09 22:16:14.000000000 -0800
+++ 25-akpm/net/sunrpc/auth_gss/auth_gss.c	2004-01-09 22:16:14.000000000 -0800
@@ -711,6 +711,7 @@ gss_marshal(struct rpc_task *task, u32 *
 	/* set verifier flavor*/
 	*p++ = htonl(RPC_AUTH_GSS);
 
+	bufout.data = (u8 *)(p + 1);
 	maj_stat = gss_get_mic(ctx->gc_gss_ctx,
 			       GSS_C_QOP_DEFAULT, 
 			       &bufin, &bufout);
@@ -719,9 +720,9 @@ gss_marshal(struct rpc_task *task, u32 *
 		       maj_stat);
 		goto out_put_ctx;
 	}
-	p = xdr_encode_netobj(p, &bufout);
+	*p++ = htonl(bufout.len);
+	p += XDR_QUADLEN(bufout.len);
 	gss_put_ctx(ctx);
-	kfree(bufout.data);
 	return p;
 out_put_ctx:
 	gss_put_ctx(ctx);
diff -puN net/sunrpc/auth_gss/gss_krb5_seal.c~nfs-12-gss_nokmalloc net/sunrpc/auth_gss/gss_krb5_seal.c
--- 25/net/sunrpc/auth_gss/gss_krb5_seal.c~nfs-12-gss_nokmalloc	2004-01-09 22:16:14.000000000 -0800
+++ 25-akpm/net/sunrpc/auth_gss/gss_krb5_seal.c	2004-01-09 22:16:14.000000000 -0800
@@ -93,8 +93,6 @@ krb5_make_token(struct krb5_ctx *ctx, in
 
 	now = jiffies;
 
-	token->data = NULL;
-
 	if (qop_req != 0)
 		goto out_err;
 
@@ -122,8 +120,6 @@ krb5_make_token(struct krb5_ctx *ctx, in
 	}
 
 	token->len = g_token_size(&ctx->mech_used, 22 + tmsglen);
-	if ((token->data = kmalloc(token->len, GFP_KERNEL)) == NULL)
-		goto out_err;
 
 	ptr = token->data;
 	g_make_token_header(&ctx->mech_used, 22 + tmsglen, &ptr, toktype);

_
